### Hierarchy

- SecureContextOptions
- CommonConnectionOptions
- ServerOpts
  - TlsOptions

## Index

### Properties

- ALPNProtocols
- SNICallback
- allowHalfOpen
- ca
- cert
- ciphers
- clientCertEngine
- crl
- dhparam
- ecdhCurve
- enableTrace
- handshakeTimeout
- honorCipherOrder
- key
- maxVersion
- minVersion
- passphrase
- pauseOnConnect
- pfx
- privateKeyEngine
- privateKeyIdentifier
- pskIdentityHint
- rejectUnauthorized
- requestCert
- secureContext
- secureOptions
- secureProtocol
- sessionIdContext
- sessionTimeout
- sigalgs
- ticketKeys

### Methods

- pskCallback

## Properties

### Optional ALPNProtocols

ALPNProtocols?: string[] | Uint8Array | Uint8Array[]

Inherited from CommonConnectionOptions.ALPNProtocols

An array of strings or a Buffer naming possible ALPN protocols. (Protocols should be ordered by their priority.)

### Optional SNICallback

SNICallback?: (servername: string, cb: (err: <internal>.Error, ctx?: SecureContext) => void) => void

Inherited from CommonConnectionOptions.SNICallback

SNICallback(servername, cb) <Function> A function that will be called if the client supports SNI TLS extension. Two arguments will be passed when called: servername and cb. SNICallback should invoke cb(null, ctx), where ctx is a SecureContext instance. (tls.createSecureContext(...) can be used to get a proper SecureContext.) If SNICallback wasn't provided the default callback with high-level API will be used (see below).

#### Type declaration

- - (servername: string, cb: (err: <internal>.Error, ctx?: SecureContext) => void): void

  - SNICallback(servername, cb) <Function> A function that will be called if the client supports SNI TLS extension. Two arguments will be passed when called: servername and cb. SNICallback should invoke cb(null, ctx), where ctx is a SecureContext instance. (tls.createSecureContext(...) can be used to get a proper SecureContext.) If SNICallback wasn't provided the default callback with high-level API will be used (see below).

    #### Parameters

    - ##### servername: string

    - ##### cb: (err: <internal>.Error, ctx?: SecureContext) => void

      - - (err: <internal>.Error, ctx?: SecureContext): void

        - #### Parameters

          - ##### err: <internal>.Error

          - ##### Optional ctx: SecureContext

          #### Returns void

### Optional allowHalfOpen

allowHalfOpen?: boolean

Inherited from ServerOpts.allowHalfOpen

Indicates whether half-opened TCP connections are allowed.

default

  false

### Optional ca

ca?: string | <internal>.Buffer | (string | <internal>.Buffer)[]

Inherited from SecureContextOptions.ca

Optionally override the trusted CA certificates. Default is to trust the well-known CAs curated by Mozilla. Mozilla's CAs are completely replaced when CAs are explicitly specified using this option.

### Optional cert

cert?: string | <internal>.Buffer | (string | <internal>.Buffer)[]

Inherited from SecureContextOptions.cert

Cert chains in PEM format. One cert chain should be provided per private key. Each cert chain should consist of the PEM formatted certificate for a provided private key, followed by the PEM formatted intermediate certificates (if any), in order, and not including the root CA (the root CA must be pre-known to the peer, see ca). When providing multiple cert chains, they do not have to be in the same order as their private keys in key. If the intermediate certificates are not provided, the peer will not be able to validate the certificate, and the handshake will fail.

### Optional ciphers

ciphers?: string

Inherited from SecureContextOptions.ciphers

Cipher suite specification, replacing the default. For more information, see modifying the default cipher suite. Permitted ciphers can be obtained via tls.getCiphers(). Cipher names must be uppercased in order for OpenSSL to accept them.

### Optional clientCertEngine

clientCertEngine?: string

Inherited from SecureContextOptions.clientCertEngine

Name of an OpenSSL engine which can provide the client certificate.

### Optional crl

crl?: string | <internal>.Buffer | (string | <internal>.Buffer)[]

Inherited from SecureContextOptions.crl

PEM formatted CRLs (Certificate Revocation Lists).

### Optional dhparam

dhparam?: string | <internal>.Buffer

Inherited from SecureContextOptions.dhparam

Diffie Hellman parameters, required for Perfect Forward Secrecy. Use openssl dhparam to create the parameters. The key length must be greater than or equal to 1024 bits or else an error will be thrown. Although 1024 bits is permissible, use 2048 bits or larger for stronger security. If omitted or invalid, the parameters are silently discarded and DHE ciphers will not be available.

### Optional ecdhCurve

ecdhCurve?: string

Inherited from SecureContextOptions.ecdhCurve

A string describing a named curve or a colon separated list of curve NIDs or names, for example P-521:P-384:P-256, to use for ECDH key agreement. Set to auto to select the curve automatically. Use crypto.getCurves() to obtain a list of available curve names. On recent releases, openssl ecparam -list_curves will also display the name and description of each available elliptic curve. Default: tls.DEFAULT_ECDH_CURVE.

### Optional enableTrace

enableTrace?: boolean

Inherited from CommonConnectionOptions.enableTrace

When enabled, TLS packet trace information is written to `stderr`. This can be used to debug TLS connection problems.

default

  false

### Optional handshakeTimeout

handshakeTimeout?: number

Abort the connection if the SSL/TLS handshake does not finish in the specified number of milliseconds. A 'tlsClientError' is emitted on the tls.Server object whenever a handshake times out. Default: 120000 (120 seconds).

### Optional honorCipherOrder

honorCipherOrder?: boolean

Inherited from SecureContextOptions.honorCipherOrder

Attempt to use the server's cipher suite preferences instead of the client's. When true, causes SSL_OP_CIPHER_SERVER_PREFERENCE to be set in secureOptions

### Optional key

key?: string | <internal>.Buffer | (<internal>.Buffer | <internal>.KeyObject)[]

Inherited from SecureContextOptions.key

Private keys in PEM format. PEM allows the option of private keys being encrypted. Encrypted keys will be decrypted with options.passphrase. Multiple keys using different algorithms can be provided either as an array of unencrypted key strings or buffers, or an array of objects in the form {pem: <string|buffer>[, passphrase: <string>]}. The object form can only occur in an array. object.passphrase is optional. Encrypted keys will be decrypted with object.passphrase if provided, or options.passphrase if it is not.

### Optional maxVersion

maxVersion?: SecureVersion

Inherited from SecureContextOptions.maxVersion

Optionally set the maximum TLS version to allow. One of `'TLSv1.3'`, `'TLSv1.2'`, `'TLSv1.1'`, or `'TLSv1'`. Cannot be specified along with the `secureProtocol` option, use one or the other. Default: `'TLSv1.3'`, unless changed using CLI options. Using `--tls-max-v1.2` sets the default to `'TLSv1.2'`. Using `--tls-max-v1.3` sets the default to `'TLSv1.3'`. If multiple of the options are provided, the highest maximum is used.

### Optional minVersion

minVersion?: SecureVersion

Inherited from SecureContextOptions.minVersion

Optionally set the minimum TLS version to allow. One of `'TLSv1.3'`, `'TLSv1.2'`, `'TLSv1.1'`, or `'TLSv1'`. Cannot be specified along with the `secureProtocol` option, use one or the other. It is not recommended to use less than TLSv1.2, but it may be required for interoperability. Default: `'TLSv1.2'`, unless changed using CLI options. Using `--tls-v1.0` sets the default to `'TLSv1'`. Using `--tls-v1.1` sets the default to `'TLSv1.1'`. Using `--tls-min-v1.3` sets the default to 'TLSv1.3'. If multiple of the options are provided, the lowest minimum is used.

### Optional passphrase

passphrase?: string

Inherited from SecureContextOptions.passphrase

Shared passphrase used for a single private key and/or a PFX.

### Optional pauseOnConnect

pauseOnConnect?: boolean

Inherited from ServerOpts.pauseOnConnect

Indicates whether the socket should be paused on incoming connections.

default

  false

### Optional pfx

pfx?: string | <internal>.Buffer | (string | <internal>.Buffer | PxfObject)[]

Inherited from SecureContextOptions.pfx

PFX or PKCS12 encoded private key and certificate chain. pfx is an alternative to providing key and cert individually. PFX is usually encrypted, if it is, passphrase will be used to decrypt it. Multiple PFX can be provided either as an array of unencrypted PFX buffers, or an array of objects in the form {buf: <string|buffer>[, passphrase: <string>]}. The object form can only occur in an array. object.passphrase is optional. Encrypted PFX will be decrypted with object.passphrase if provided, or options.passphrase if it is not.

### Optional privateKeyEngine

privateKeyEngine?: string

Inherited from SecureContextOptions.privateKeyEngine

Name of an OpenSSL engine to get private key from. Should be used together with privateKeyIdentifier.

### Optional privateKeyIdentifier

privateKeyIdentifier?: string

Inherited from SecureContextOptions.privateKeyIdentifier

Identifier of a private key managed by an OpenSSL engine. Should be used together with privateKeyEngine. Should not be set together with key, because both options define a private key in different ways.

### Optional pskIdentityHint

pskIdentityHint?: string

hint to send to a client to help with selecting the identity during TLS-PSK negotiation. Will be ignored in TLS 1.3. Upon failing to set pskIdentityHint `tlsClientError` will be emitted with `ERR_TLS_PSK_SET_IDENTIY_HINT_FAILED` code.

### Optional rejectUnauthorized

rejectUnauthorized?: boolean

Inherited from CommonConnectionOptions.rejectUnauthorized

If true the server will reject any connection which is not authorized with the list of supplied CAs. This option only has an effect if requestCert is true.

default

  true

### Optional requestCert

requestCert?: boolean

Inherited from CommonConnectionOptions.requestCert

If true the server will request a certificate from clients that connect and attempt to verify that certificate. Defaults to false.

### Optional secureContext

secureContext?: SecureContext

Inherited from CommonConnectionOptions.secureContext

An optional TLS context object from tls.createSecureContext()

### Optional secureOptions

secureOptions?: number

Inherited from SecureContextOptions.secureOptions

Optionally affect the OpenSSL protocol behavior, which is not usually necessary. This should be used carefully if at all! Value is a numeric bitmask of the SSL_OP_* options from OpenSSL Options

### Optional secureProtocol

secureProtocol?: string

Inherited from SecureContextOptions.secureProtocol

Legacy mechanism to select the TLS protocol version to use, it does not support independent control of the minimum and maximum version, and does not support limiting the protocol to TLSv1.3. Use minVersion and maxVersion instead. The possible values are listed as SSL_METHODS, use the function names as strings. For example, use 'TLSv1_1_method' to force TLS version 1.1, or 'TLS_method' to allow any TLS protocol version up to TLSv1.3. It is not recommended to use TLS versions less than 1.2, but it may be required for interoperability. Default: none, see minVersion.

### Optional sessionIdContext

sessionIdContext?: string

Inherited from SecureContextOptions.sessionIdContext

Opaque identifier used by servers to ensure session state is not shared between applications. Unused by clients.

### Optional sessionTimeout

sessionTimeout?: number

Overrides SecureContextOptions.sessionTimeout

The number of seconds after which a TLS session created by the server will no longer be resumable. See Session Resumption for more information. Default: 300.

### Optional sigalgs

sigalgs?: string

Inherited from SecureContextOptions.sigalgs

Colon-separated list of supported signature algorithms. The list can contain digest algorithms (SHA256, MD5 etc.), public key algorithms (RSA-PSS, ECDSA etc.), combination of both (e.g 'RSA+SHA384') or TLS v1.3 scheme names (e.g. rsa_pss_pss_sha512).

### Optional ticketKeys

ticketKeys?: <internal>.Buffer

Overrides SecureContextOptions.ticketKeys

48-bytes of cryptographically strong pseudo-random data.

## Methods

### Optional pskCallback

- pskCallback(socket: TLSSocket, identity: string): TypedArray | DataView

- #### Parameters

  - ##### socket: TLSSocket

  - ##### identity: string

    identity parameter sent from the client.

  #### Returns TypedArray | DataView

  pre-shared key that must either be a buffer or `null` to stop the negotiation process. Returned PSK must be compatible with the selected cipher's digest.

  When negotiating TLS-PSK (pre-shared keys), this function is called with the identity provided by the client. If the return value is `null` the negotiation process will stop and an "unknown_psk_identity" alert message will be sent to the other party. If the server wishes to hide the fact that the PSK identity was not known, the callback must provide some random data as `psk` to make the connection fail with "decrypt_error" before negotiation is finished. PSK ciphers are disabled by default, and using TLS-PSK thus requires explicitly specifying a cipher suite with the `ciphers` option. More information can be found in the RFC 4279.

Generated using TypeDoc